//---------------------------------------------------------------------------
#ifndef UTAvionH
#define UTAvionH
//---------------------------------------------------------------------------
#include <fstream>
#include "UtMatriz.h"
using namespace std;

typedef Matriz<bool> matrizBool;

class tAvion
{
private:
        int capacidad;
        int numAsientosOcupados;
        int numAsientosFacturados;
        matrizBool* distribucion;
public:
        tAvion(int nC = 1, int nF = 1);
        ~tAvion();
        // operaciones de consulta
        int dameCapacidad()const{return capacidad;}
        int dameAsientosOcupados()const{return numAsientosOcupados;}
        int dameAsientosFacturados()const{return numAsientosFacturados;}
        // modificadoras
        bool reservaAsiento();
        bool eliminaAsiento();
        // operaciones con ficheros
        bool salvar(ofstream& sal)const;
        bool cargar(ifstream& ent);

        const matrizBool* dameDistribucion() const {return distribucion;};
        bool facturAsiento(unsigned int col, unsigned int fil);
};

#endif

