//---------------------------------------------------------------------------

#ifndef UtListaOrdH
#define UtListaOrdH

#include "UtLista.h"
//---------------------------------------------------------------------------

template <typename T, bool(*Menor)(const T &, const T &)> class ListaOrd : protected Lista<T>
{
public:
        ListaOrd():Lista<T>() {};
        virtual ~ListaOrd() throw() {};
        virtual void clear() throw() {Lista<T>::clear();};
        virtual unsigned int size() const throw() {return Lista<T>::size();};
        virtual bool empty() const throw() {return Lista<T>::empty();};
        virtual void at(int Pos, T& E) const throw() {Lista<T>::at(Pos, E);};
        virtual const T& at(int Pos) const throw(ErrRango) {return Lista<T>::at(Pos);};
        virtual bool find(const T& E, unsigned int& Pos) const throw() //sita el punto de inters y devuelve la posicin.
        {
                /*iniciaPI();
                while(contPI() < size() && Menor(elemPI(), E))
                {
                        avanzaPI();
                }
                Pos = contPI();
                return (Pos != size());*/
                if(empty())
                {
                        return false;
                }
                else
                {
                        if(contPI() == size())
                        {
                                retrocedePI();
                        }
                        if(Menor(elemPI(), E))
                        {
                                avanzaPI();
                                while((contPI() < size()) && (Menor(elemPI(), E)))
                                {
                                        avanzaPI();
                                }
                        }
                        else
                        {
                                if(Menor(E, elemPI()))
                                {
                                        while((contPI() > 0) && (Menor(E, elemPI())))
                                        {
                                                retrocedePI();
                                        }
                                }
                        }
                        Pos = contPI();
                        if(Pos == size())
                        {
                                return false;
                        }
                        else return (!(Menor(E, elemPI())) && !(Menor(elemPI(), E)));
                }
        };
        virtual bool insert(const T& E) throw(bad_alloc) //busca E, si no existe invoca a insertPI(E). Si lo encuentra devuelve false.
        {
                unsigned int pos;
                if(!find(E, pos))
                {
                        insertPI(E);
                        return true;
                }
                else return false;
        };
        virtual void erase(int Pos) throw(ErrRango)
        {
                posicionPI(Pos);
                quitaPI();
        }
};

//---------------------------------------------------------------------------
//template <typename T, bool(*Menor)>
//bool ListaOrd<T, Menor>::find...


#endif
