//---------------------------------------------------------------------------
#ifndef UtLocalizadorH
#define UtLocalizadorH
//---------------------------------------------------------------------------
#include <string>
#include <fstream>
#include "UtAvion.h"
using namespace std;

enum estadoLoc {vacio, reservado, esperar, facturad};
string EstToStr(estadoLoc es);

class tLocalizador
{
private:
        int idVuelo;
        int idLocalizador;
        estadoLoc estado;
public:
        tLocalizador(int iv=-1, int ia=-1, estadoLoc est=vacio);
        ~tLocalizador() {};
        AnsiString LocToStr();
        int dameIdLocalizador()const {return idLocalizador;};
        int dameIdVuelo()const {return idVuelo;};
        bool libre()const {return estado==vacio;};
        void liberar(){estado=vacio;}
        void reservar(){estado=reservado;}
        bool facturado() const {return estado==facturad;};
        void facturar() {estado=facturad;};
        bool salvar(ofstream& sal)const;
        bool cargar(ifstream& ent);
        tLocalizador operator=(const tLocalizador& loc);
};

#endif
//---------------------------------------------------------------------------

