//---------------------------------------------------------------------------
#ifndef UtVueloBajoCosteH
#define UtVueloBajoCosteH

#include "UtVuelo.h"
#include "UColaIter.h"
//---------------------------------------------------------------------------

typedef ColaIter<tLocalizador> tColaLocalizadores;
//class tColaLocalizadores; //declaracin adelantada

class tVueloBajoCoste:public tVuelo
{
private:
        tColaLocalizadores cola; //cola de espera
        int idLoc;  // identificadores para localizadores
        tVueloBajoCoste(const tVueloBajoCoste& v){}; // para que no se puedan usar
        tVueloBajoCoste& operator=(const tVueloBajoCoste& v){return *this;};
public:
        tVueloBajoCoste():tVuelo(){idLoc = 0;};
        tVueloBajoCoste(const string& origen, const string& destino, const tHora& hSalida,
                 const tHora& duracion, const string& compAerea, int idV, int precio):tVuelo(
                 origen, destino, hSalida, duracion, compAerea, idV, precio) {idLoc = 0;};
        virtual ~tVueloBajoCoste() {};
        virtual bool hazReserva(tLocalizador& loc);
        virtual bool eliminaReserva(const tLocalizador& loc);
        // operaciones con ficheros
        virtual bool salvar(ofstream& sal)const;
        virtual bool cargar(ifstream& ent);
};

#endif

