//---------------------------------------------------------------------------

#ifndef UErroresH
#define UErroresH

#include <stdexcept>
using namespace std;
//---------------------------------------------------------------------------

class Error
{
public:
        ~Error() {};
        string getMsg() {return mensaje;};
protected:
        Error(string mens=""):mensaje(mens){};
private:
        string mensaje;
};

class ErrRango: public Error
{
public:
        ErrRango(string mens="Error: Fuera de Rango."):Error(mens) {};
};

class ErrVacia: public Error
{
public:
        ErrVacia(string mens="Error: La lista esta vacia."):Error(mens) {};
};

class ErrGenerico: public Error
{
public:
        ErrGenerico(string mens="Error: Failure."):Error(mens) {};
};

class ErrIter: public Error
{
public:
        ErrIter(string mens="Error de iterador."):Error(mens) {};
};

#endif
