//---------------------------------------------------------------------------

#ifndef UtNodoH
#define UtNodoH

using namespace std;
//---------------------------------------------------------------------------

template <class T> class Nodo
{
public:
        Nodo() {sig = ant = NULL;};
        Nodo(T elem, Nodo* ant = NULL, Nodo* sig = NULL) {this->sig; this->ant; this->elem = elem;};
        Nodo(Nodo* ant, Nodo* sig) {this->sig; this->ant;};
        ~Nodo() {};
        Nodo* getNext() {return sig;};
        Nodo* getPrior() {return ant;};
        void setNext(Nodo* nodo) {sig = nodo;};
        void setPrior(Nodo* nodo) {ant = nodo;};
        T getElem() {return elem;};
        void setElem(T elem) {this->elem = elem;};

private:
        T elem;
        Nodo<T>* sig, ant;
};

template <class T> class PuntoInt
{
public:
        PuntoInt(Nodo<T>* nod = NULL) {nodo = nod; cont = 0;};
        ~PuntoInt() {delete nodo;};
        void setCont(unsigned int co) {cont = co;};
        unsigned int getCont() {return cont;};
        void next() {nodo = nodo->getNext(); cont++;};
        void prior() {nodo = nodo->getPrior(); cont--;};
        Nodo<T>* nodo() {return nodo;};

private:
        Nodo<T>* nodo;
        unsigned int cont;
};

#endif
