//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtVueloNormal.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

bool tVueloNormal::hazReserva(tLocalizador& loc)
{
        if(getAvion()->dameAsientosOcupados() < getAvion()->dameCapacidad())
        {
                unsigned int i = 0;
                while( i < localizadores.size() && !localizadores.at(i).libre())
                {
                        i++;
                }
                if( i == localizadores.size())
                {
                        tLocalizador loca(IdVuelo, i, reservado);
                        localizadores.push_back(loca);
                        loc = loca;
                }
                else
                {
                        localizadores.at(i).reservar();
                        loc = localizadores.at(i);
                }
                avion->reservaAsiento();
                return true;
        }
        else
        {
                return false;
        }
}

bool tVueloNormal::eliminaReserva(const tLocalizador& loc)
{
        if(getAvion()->dameCapacidad() > loc.dameIdLocalizador() &&
           !localizadores.at(loc.dameIdLocalizador()).libre() &&
           !localizadores.at(loc.dameIdLocalizador()).facturado())
        {
                localizadores.at(loc.dameIdLocalizador()).liberar();
                avion->eliminaAsiento();
                return true;
        }
        else
        {
                return false;
        }
}


bool tVueloNormal::salvar(ofstream& sal) const
{
        tipoVuelo tv = normal;
        sal.write((char *)& tv, sizeof(tipoVuelo));
        tVuelo::salvar(sal);
        return sal;
}

